> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Create an Instance Type

POST https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/instance/type
Content-Type: application/json

Create an Instance Type for Infrastructure Provider.

Org must have an Infrastructure Provider entity. User must have `FORGE_PROVIDER_ADMIN` authorization role.


Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/instance-type/create-instance-type

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/instance/type:
    post:
      operationId: create-instance-type
      summary: Create an Instance Type
      description: >
        Create an Instance Type for Infrastructure Provider.


        Org must have an Infrastructure Provider entity. User must have
        `FORGE_PROVIDER_ADMIN` authorization role.
      tags:
        - subpackage_instanceType
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InstanceType'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/InstanceTypeCreateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    InstanceTypeCapabilityCreateRequestType:
      type: string
      enum:
        - CPU
        - Memory
        - Storage
        - Network
        - GPU
        - InfiniBand
        - DPU
      description: Type of the Capability
      title: InstanceTypeCapabilityCreateRequestType
    InstanceTypeCapabilityCreateRequest:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/InstanceTypeCapabilityCreateRequestType'
          description: Type of the Capability
        name:
          type: string
          description: Name of the Capability component
        frequency:
          type:
            - string
            - 'null'
          description: Frequency of the Capability component, if available
        capacity:
          type:
            - string
            - 'null'
          description: Capacity of the Capability component, if applicable
        vendor:
          type:
            - string
            - 'null'
          description: Vendor of the Capability component, if available
        count:
          type:
            - integer
            - 'null'
          description: Count of the Capability component
        inactiveDevices:
          type: array
          items:
            type: integer
          description: >-
            Indices of those devices that are inactive, only valid for
            InfiniBand Capability type
        deviceType:
          type:
            - string
            - 'null'
          description: Device Type of the Capability component, if available
      description: Describes request attributes for Instance Type Capability
      title: InstanceTypeCapabilityCreateRequest
    InstanceTypeCreateRequest:
      type: object
      properties:
        name:
          type: string
        description:
          type: string
        siteId:
          type: string
          format: uuid
        labels:
          $ref: '#/components/schemas/Labels'
        controllerMachineType:
          type: string
        machineCapabilities:
          type: array
          items:
            $ref: '#/components/schemas/InstanceTypeCapabilityCreateRequest'
      required:
        - name
        - siteId
      description: Request data to create an Instance Type
      title: InstanceTypeCreateRequest
    MachineCapabilityType:
      type: string
      enum:
        - CPU
        - Memory
        - Storage
        - Network
        - GPU
        - InfiniBand
        - DPU
      description: Type of the Capability
      title: MachineCapabilityType
    MachineCapability:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/MachineCapabilityType'
          description: Type of the Capability
        name:
          type: string
          description: Name of the Capability component
        frequency:
          type:
            - string
            - 'null'
          description: Frequency of the Capability component, if available
        cores:
          type:
            - integer
            - 'null'
          description: Number of Cores in the Capability component, if applicable
        threads:
          type:
            - integer
            - 'null'
          description: Number of Threads in the Capability component, if applicable
        capacity:
          type:
            - string
            - 'null'
          description: Capacity of the Capability component, if applicable
        vendor:
          type:
            - string
            - 'null'
          description: Vendor of the Capability component, if available
        inactiveDevices:
          type: array
          items:
            type: integer
          description: A list of inactive devices
        count:
          type:
            - integer
            - 'null'
          description: Count of the Capability component
        deviceType:
          type:
            - string
            - 'null'
          description: Device Type of the Capability component, if available
      description: Describes capabilities of a Machine
      title: MachineCapability
    Deprecation:
      type: object
      properties:
        attribute:
          type:
            - string
            - 'null'
        queryParam:
          type:
            - string
            - 'null'
        endpoint:
          type:
            - string
            - 'null'
        replacedBy:
          type:
            - string
            - 'null'
        takeActionBy:
          type: string
          format: date-time
        notice:
          type: string
      description: Details of a particular deprecation in NCX Infra Controller API
      title: Deprecation
    MachineInstanceType:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: >-
            Deprecated: Use `machineId` when identifying a Machine/Instance Type
            association. This field will be removed on July 9th, 2026 0:00 UTC.
        machineId:
          type: string
        instanceTypeId:
          type: string
          format: uuid
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Associates a machine with an Instance Type
      title: MachineInstanceType
    InstanceTypeAllocationStats:
      type: object
      properties:
        assigned:
          type: integer
          description: Total number of Machines assigned to this Instance Type
        total:
          type: integer
          description: >-
            Total number of Machines allocated to different Tenants for this
            Instance Type
        used:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type currently
            being used by Tenants
        unused:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type that is
            currently not being used by Tenants
        unusedUsable:
          type: integer
          description: >-
            Total number of allocated Machines of this Instance Type that is
            currently not in use but in Ready state, therefore can be
            provisioned by Tenant
        maxAllocatable:
          type: integer
          description: >-
            Maximum number of Machines of this Instance Type that can be
            allocated to a Tenant
      description: Allocation statistics for Instance Type
      title: InstanceTypeAllocationStats
    InstanceTypeStatus:
      type: string
      enum:
        - Pending
        - Registering
        - Ready
        - Deleting
        - Error
      description: Status values for Instance Type objects
      title: InstanceTypeStatus
    StatusDetail:
      type: object
      properties:
        status:
          type: string
        message:
          type: string
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Describes the details of a status transition for a resource
      title: StatusDetail
    InstanceType:
      type: object
      properties:
        id:
          type: string
          format: uuid
        name:
          type: string
        description:
          type: string
        controllerMachineType:
          type: string
        infrastructureProviderId:
          type: string
          format: uuid
        siteId:
          type: string
          format: uuid
        labels:
          $ref: '#/components/schemas/Labels'
        machineCapabilities:
          type: array
          items:
            $ref: '#/components/schemas/MachineCapability'
        machineInstanceTypes:
          type: array
          items:
            $ref: '#/components/schemas/MachineInstanceType'
          description: Available only for Providers
        allocationStats:
          $ref: '#/components/schemas/InstanceTypeAllocationStats'
          description: summary of machine counts by allocation status
        status:
          $ref: '#/components/schemas/InstanceTypeStatus'
        statusHistory:
          type: array
          items:
            $ref: '#/components/schemas/StatusDetail'
        deprecations:
          type: array
          items:
            $ref: '#/components/schemas/Deprecation'
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Instance types describe a set of machines that match a certain criteria
      title: InstanceType
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python example-1
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type"

payload = {
    "name": "x3.large",
    "siteId": "8d97fa69-9199-49ff-bcf3-168c62d3874e",
    "description": "Part of X family, the X3 Large features increased compute power",
    "labels": {
        "region": "portland",
        "env": "staging"
    },
    "machineCapabilities": [
        {
            "type": "CPU",
            "name": "Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz",
            "frequency": "3.0GHz",
            "count": 2
        },
        {
            "type": "Memory",
            "name": "Corsair Vengeance LPX",
            "capacity": "32GB",
            "count": 4
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript example-1
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"x3.large","siteId":"8d97fa69-9199-49ff-bcf3-168c62d3874e","description":"Part of X family, the X3 Large features increased compute power","labels":{"region":"portland","env":"staging"},"machineCapabilities":[{"type":"CPU","name":"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz","frequency":"3.0GHz","count":2},{"type":"Memory","name":"Corsair Vengeance LPX","capacity":"32GB","count":4}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-1
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type"

	payload := strings.NewReader("{\n  \"name\": \"x3.large\",\n  \"siteId\": \"8d97fa69-9199-49ff-bcf3-168c62d3874e\",\n  \"description\": \"Part of X family, the X3 Large features increased compute power\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"staging\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"CPU\",\n      \"name\": \"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz\",\n      \"frequency\": \"3.0GHz\",\n      \"count\": 2\n    },\n    {\n      \"type\": \"Memory\",\n      \"name\": \"Corsair Vengeance LPX\",\n      \"capacity\": \"32GB\",\n      \"count\": 4\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-1
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"x3.large\",\n  \"siteId\": \"8d97fa69-9199-49ff-bcf3-168c62d3874e\",\n  \"description\": \"Part of X family, the X3 Large features increased compute power\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"staging\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"CPU\",\n      \"name\": \"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz\",\n      \"frequency\": \"3.0GHz\",\n      \"count\": 2\n    },\n    {\n      \"type\": \"Memory\",\n      \"name\": \"Corsair Vengeance LPX\",\n      \"capacity\": \"32GB\",\n      \"count\": 4\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java example-1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"x3.large\",\n  \"siteId\": \"8d97fa69-9199-49ff-bcf3-168c62d3874e\",\n  \"description\": \"Part of X family, the X3 Large features increased compute power\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"staging\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"CPU\",\n      \"name\": \"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz\",\n      \"frequency\": \"3.0GHz\",\n      \"count\": 2\n    },\n    {\n      \"type\": \"Memory\",\n      \"name\": \"Corsair Vengeance LPX\",\n      \"capacity\": \"32GB\",\n      \"count\": 4\n    }\n  ]\n}")
  .asString();
```

```php example-1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type', [
  'body' => '{
  "name": "x3.large",
  "siteId": "8d97fa69-9199-49ff-bcf3-168c62d3874e",
  "description": "Part of X family, the X3 Large features increased compute power",
  "labels": {
    "region": "portland",
    "env": "staging"
  },
  "machineCapabilities": [
    {
      "type": "CPU",
      "name": "Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz",
      "frequency": "3.0GHz",
      "count": 2
    },
    {
      "type": "Memory",
      "name": "Corsair Vengeance LPX",
      "capacity": "32GB",
      "count": 4
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp example-1
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"x3.large\",\n  \"siteId\": \"8d97fa69-9199-49ff-bcf3-168c62d3874e\",\n  \"description\": \"Part of X family, the X3 Large features increased compute power\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"staging\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"CPU\",\n      \"name\": \"Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz\",\n      \"frequency\": \"3.0GHz\",\n      \"count\": 2\n    },\n    {\n      \"type\": \"Memory\",\n      \"name\": \"Corsair Vengeance LPX\",\n      \"capacity\": \"32GB\",\n      \"count\": 4\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift example-1
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "x3.large",
  "siteId": "8d97fa69-9199-49ff-bcf3-168c62d3874e",
  "description": "Part of X family, the X3 Large features increased compute power",
  "labels": [
    "region": "portland",
    "env": "staging"
  ],
  "machineCapabilities": [
    [
      "type": "CPU",
      "name": "Intel(R) Xeon(R) Gold 6354 CPU @ 3.00GHz",
      "frequency": "3.0GHz",
      "count": 2
    ],
    [
      "type": "Memory",
      "name": "Corsair Vengeance LPX",
      "capacity": "32GB",
      "count": 4
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

```python example-2
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type"

payload = {
    "name": "infiniband-mt2910-4x2",
    "siteId": "8d97fa69-9199-49ff-bcf3-168c62d3874e",
    "description": "Machines with 2 active InfiniBand MT2910 NICs",
    "labels": {
        "region": "portland",
        "env": "dev"
    },
    "machineCapabilities": [
        {
            "type": "InfiniBand",
            "name": "MT2910 Family [ConnectX-7]",
            "vendor": "Mellanox Technologies",
            "count": 4,
            "inactiveDevices": [1, 3]
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript example-2
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"infiniband-mt2910-4x2","siteId":"8d97fa69-9199-49ff-bcf3-168c62d3874e","description":"Machines with 2 active InfiniBand MT2910 NICs","labels":{"region":"portland","env":"dev"},"machineCapabilities":[{"type":"InfiniBand","name":"MT2910 Family [ConnectX-7]","vendor":"Mellanox Technologies","count":4,"inactiveDevices":[1,3]}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go example-2
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type"

	payload := strings.NewReader("{\n  \"name\": \"infiniband-mt2910-4x2\",\n  \"siteId\": \"8d97fa69-9199-49ff-bcf3-168c62d3874e\",\n  \"description\": \"Machines with 2 active InfiniBand MT2910 NICs\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"dev\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"InfiniBand\",\n      \"name\": \"MT2910 Family [ConnectX-7]\",\n      \"vendor\": \"Mellanox Technologies\",\n      \"count\": 4,\n      \"inactiveDevices\": [\n        1,\n        3\n      ]\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby example-2
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"infiniband-mt2910-4x2\",\n  \"siteId\": \"8d97fa69-9199-49ff-bcf3-168c62d3874e\",\n  \"description\": \"Machines with 2 active InfiniBand MT2910 NICs\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"dev\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"InfiniBand\",\n      \"name\": \"MT2910 Family [ConnectX-7]\",\n      \"vendor\": \"Mellanox Technologies\",\n      \"count\": 4,\n      \"inactiveDevices\": [\n        1,\n        3\n      ]\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java example-2
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"infiniband-mt2910-4x2\",\n  \"siteId\": \"8d97fa69-9199-49ff-bcf3-168c62d3874e\",\n  \"description\": \"Machines with 2 active InfiniBand MT2910 NICs\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"dev\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"InfiniBand\",\n      \"name\": \"MT2910 Family [ConnectX-7]\",\n      \"vendor\": \"Mellanox Technologies\",\n      \"count\": 4,\n      \"inactiveDevices\": [\n        1,\n        3\n      ]\n    }\n  ]\n}")
  .asString();
```

```php example-2
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type', [
  'body' => '{
  "name": "infiniband-mt2910-4x2",
  "siteId": "8d97fa69-9199-49ff-bcf3-168c62d3874e",
  "description": "Machines with 2 active InfiniBand MT2910 NICs",
  "labels": {
    "region": "portland",
    "env": "dev"
  },
  "machineCapabilities": [
    {
      "type": "InfiniBand",
      "name": "MT2910 Family [ConnectX-7]",
      "vendor": "Mellanox Technologies",
      "count": 4,
      "inactiveDevices": [
        1,
        3
      ]
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp example-2
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"infiniband-mt2910-4x2\",\n  \"siteId\": \"8d97fa69-9199-49ff-bcf3-168c62d3874e\",\n  \"description\": \"Machines with 2 active InfiniBand MT2910 NICs\",\n  \"labels\": {\n    \"region\": \"portland\",\n    \"env\": \"dev\"\n  },\n  \"machineCapabilities\": [\n    {\n      \"type\": \"InfiniBand\",\n      \"name\": \"MT2910 Family [ConnectX-7]\",\n      \"vendor\": \"Mellanox Technologies\",\n      \"count\": 4,\n      \"inactiveDevices\": [\n        1,\n        3\n      ]\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift example-2
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "infiniband-mt2910-4x2",
  "siteId": "8d97fa69-9199-49ff-bcf3-168c62d3874e",
  "description": "Machines with 2 active InfiniBand MT2910 NICs",
  "labels": [
    "region": "portland",
    "env": "dev"
  ],
  "machineCapabilities": [
    [
      "type": "InfiniBand",
      "name": "MT2910 Family [ConnectX-7]",
      "vendor": "Mellanox Technologies",
      "count": 4,
      "inactiveDevices": [1, 3]
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/instance/type")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```